//needed libs
#include <gtk/gtk.h>
#include <glib.h>
#include <stdlib.h>
#include <unistd.h>
#include <stdio.h>
#include <string.h>
#include <X11/Xatom.h>
//tray object
#include "eggtrayicon.h"
//xchat plugin core
#include "xchat-plugin.h"
//notify icons
#include "xchatpng.h"
#include "xchatredpng.h"
#include "xchatbluepng.h"
#include "xchatdccxpm.h"
#include "xchatdiscxpm.h"
#include "xchatinvxpm.h"
#include "xchatnotoutxpm.h"
#include "xchatnotinxpm.h"
#include "xchathelp.h"
//tray menu icons
#include "xchatquitpng.h"
#include "xchatbrowser.h"
#include "xchatplayer.h"
#include "xchatemail.h"
#include "xchatmaxxpm.h"
#include "xchatminxpm.h"
#include "xchatsettings.h"
#include "xchatgoaway.h"
#include "xchatbackaway.h"

//xchat plugin var
static xchat_plugin *ph;
static xchat_context *flash_ctx = NULL;
static xchat_context *focus_ctx;
//notify icon
static GdkPixbuf *pix_xchat;
static GdkPixbuf *pix_xchat_red;
static GdkPixbuf *pix_xchat_blue;
static GdkPixbuf *pix_xchat_dcc;
static GdkPixbuf *pix_xchat_disc;
static GdkPixbuf *pix_xchat_inv;
static GdkPixbuf *pix_xchat_notin;
static GdkPixbuf *pix_xchat_notout;
static GdkPixbuf *buffer9;
//set flashing icon
static GdkPixbuf *icontype;
//core var
static GHashTable *servers_names = NULL;
static gint flash_id = 0;
static GtkWidget *tray_icon;
static GtkWidget *tray_icon_image;
static GtkWidget *status_menu;
static GtkWidget *spinbutton;
static GtkWidget *checkbutton3;
static GtkWidget *browser_text,*email_text,*player_text;
static GtkWidget *away1,*away2,*away3,*away_nick_box,*away_nick_pass_box,*away_text;
GtkWidget **app2set;
static GtkTooltips *tray_icon_tooltip;
//settings items array
static char ppath[150];
static char epath[150];
static char bpath[150];
static char away_msg1[150];
static char away_msg2[150];
static char away_msg3[150];
static char away_nick[150];
static char away_pass[150];
//settings items
const char* ppath1;
const char* epath1;
const char* bpath1;
const char* amsg1;
const char* amsg2;
const char* amsg3;
const char* message;
const char* awaynick;
const char* awaypass;
//control var
static gboolean KDE=TRUE;
static gboolean highlight;
static gboolean query;
static gboolean disconnection;
static gboolean kill;
static gboolean kick;
static gboolean dcc_chat;
static gboolean dcc_send;
static gboolean invite;
static gboolean notify_list;
static gboolean go_change=TRUE;
static gboolean go_identify=TRUE;
static gboolean edit=TRUE;
static gboolean global_away=FALSE;
static gboolean global_away_temp=FALSE;
static gint status = 1;
static gint onExit = 1;
static char* version;
gboolean window_manager_modified;
static gint flash_interval=500;
//some needed prototypes
static gboolean tray_clicked (GtkWidget *event_box, GdkEventButton *event, gpointer data);
static gboolean tray_menu (GtkWidget *event_box, GdkEventButton *event, gpointer data);
static void away_use_yes(GtkWidget *button, void *data);
static void away_use_not(GtkWidget *button, void *data);
static void away_ident_yes(GtkWidget *button, void *data);
static void away_ident_not(GtkWidget *button, void *data);
void set_tray();
void select_event_tab();
static void tray_init();
static void tray_init_gui();
static void flash_stop();

//START IMPLEMENTATION

//WARNINGS

//alerts if file settings has not been created or not readable
void show_warning() {

	GtkWidget *window;
	GtkWidget *button,*titlebox,*box1,*box2;
	GtkWidget *label;

	xchat_printf(ph,"SysTray Integration Plugin not setted properly, please set it now");

	//create box and window
	window = gtk_window_new (GTK_WINDOW_TOPLEVEL);
	gtk_window_set_title (GTK_WINDOW (window), "Settings Missing");
	gtk_window_set_resizable(GTK_WINDOW (window),FALSE);
	gtk_container_set_border_width (GTK_CONTAINER (window), 10);

	//first container box
	box1 = gtk_vbox_new (FALSE, 0);
	gtk_container_add (GTK_CONTAINER (window), box1);
	gtk_widget_show (box1);

	//other containers
	titlebox = gtk_hbox_new (FALSE, 0);
    	gtk_box_pack_start (GTK_BOX (box1), titlebox, FALSE, FALSE, 0);
   	gtk_widget_show (titlebox);

	box2 = gtk_hbox_new (FALSE, 10);
    	gtk_box_pack_start (GTK_BOX (box1), box2, FALSE, FALSE, 0);
   	gtk_widget_show (box2);

	label = gtk_label_new ("SysTray Integration Plugin Settings\n\nare corrupted, not setted properly or missing.\n\nPlease set it now to use Plugin Features\n\n");
  	gtk_box_pack_start (GTK_BOX (titlebox), label, FALSE, FALSE, 0);
  	gtk_widget_show (label);

	//set now
	button = gtk_button_new_with_label ("Set it now");
   	g_signal_connect (G_OBJECT (button), "clicked", G_CALLBACK (set_tray), NULL);
	g_signal_connect_swapped (G_OBJECT (button), "clicked",G_CALLBACK (gtk_widget_destroy),G_OBJECT (window));
    	gtk_box_pack_start (GTK_BOX (box2), button, FALSE, FALSE, 40);
    	gtk_widget_show (button);

	//do not set
	button = gtk_button_new_with_label ("I'll set it later");
	g_signal_connect_swapped (G_OBJECT (button), "clicked",G_CALLBACK (gtk_widget_destroy),G_OBJECT (window));
	gtk_box_pack_start (GTK_BOX (box2), button, FALSE, FALSE, 40);
	gtk_widget_show (button);
	gtk_widget_show (box1);
	gtk_widget_show (box2);
	gtk_widget_show (window);
}

//2 sec time to fix seg. fault
void unload_plugin() {

	xchat_command(ph, "timer 2 unload systray");

}

//alerts when you change win manager settings
void show_win_manager_warning() {

   GtkWidget *dialog=gtk_message_dialog_new (NULL,
                                  GTK_DIALOG_DESTROY_WITH_PARENT,
                                  GTK_MESSAGE_ERROR,
                                  GTK_BUTTONS_CLOSE,
                                  "You have changed your Window Manager.\n\nPlease restart plugin or XChat (suggested) now.\n\nXChat can become instable if you continue.");
 gtk_window_set_title (GTK_WINDOW (dialog), "Attention, Important Warning!");
 gtk_dialog_run (GTK_DIALOG (dialog));
 gtk_widget_destroy (dialog);


}

//if version is old
void version_warning() {

	GtkWidget *window;
	GtkWidget *button,*titlebox,*box1,*box2;
	GtkWidget *label;

	xchat_print (ph, "Your XChat version is too old!\n");
	xchat_print (ph, "You will not be able to use: Minimize, Restore, Exit, Focus features.\n");
	xchat_print (ph, "Please update it http://www.xchat.org\n");

	//create box and window
	window = gtk_window_new (GTK_WINDOW_TOPLEVEL);
	gtk_window_set_title (GTK_WINDOW (window), "Version Problem");
	gtk_window_set_resizable(GTK_WINDOW (window),FALSE);
	gtk_container_set_border_width (GTK_CONTAINER (window), 10);

	//first container box
	box1 = gtk_vbox_new (FALSE, 0);
	gtk_container_add (GTK_CONTAINER (window), box1);
	gtk_widget_show (box1);

	//other containers
	titlebox = gtk_hbox_new (FALSE, 0);
    	gtk_box_pack_start (GTK_BOX (box1), titlebox, FALSE, FALSE, 0);
   	gtk_widget_show (titlebox);

	box2 = gtk_hbox_new (FALSE, 10);
    	gtk_box_pack_start (GTK_BOX (box1), box2, FALSE, FALSE, 0);
   	gtk_widget_show (box2);

	label = gtk_label_new ("You have an old XChat version.\n\nThis means you will not be able to use some features like:\n  1) Restore\n  2) Minimize\n  3) Exit\n  4) Full Focus feature\n\n However you can use SysTray Plugin without them\n or you can choose to unload plugin.\n\n");
  	gtk_box_pack_start (GTK_BOX (titlebox), label, FALSE, FALSE, 0);
  	gtk_widget_show (label);

	//use
	button = gtk_button_new_with_label ("Use it");
   	g_signal_connect_swapped (G_OBJECT (button), "clicked",G_CALLBACK (gtk_widget_destroy),G_OBJECT (window));
    	gtk_box_pack_start (GTK_BOX (box2), button, FALSE, FALSE, 60);
    	gtk_widget_show (button);

	//unload
	button = gtk_button_new_with_label ("Unload");
	g_signal_connect (G_OBJECT (button), "clicked",G_CALLBACK (unload_plugin),0);
	g_signal_connect_swapped (G_OBJECT (button), "clicked",G_CALLBACK (gtk_widget_destroy),G_OBJECT (window));
	gtk_box_pack_start (GTK_BOX (box2), button, FALSE, FALSE, 40);
	gtk_widget_show (button);
	gtk_widget_show (box1);
	gtk_widget_show (box2);
	gtk_widget_show (window);
}

//SAVING AND READING SETTINGS

//save function
static void write2file(gboolean control) {

	FILE *systray;
	char path[150];
	sprintf(path,"%s/systray.conf", xchat_get_info(ph, "xchatdir"));
	systray = fopen(path,"w");
	if (systray != NULL) {
		fprintf(systray,"%s\n",bpath1);
		fprintf(systray,"%s\n",epath1);
		fprintf(systray,"%s\n",ppath1);
		fprintf(systray,"%s\n",amsg1);
		fprintf(systray,"%s\n",amsg2);
		fprintf(systray,"%s\n",amsg3);
		fprintf(systray,"%s\n",awaynick);
		fprintf(systray,"%s\n",awaypass);
		if (KDE ==TRUE) fprintf(systray,"1\n");
		else fprintf(systray,"0\n");
		if (go_change== TRUE) fprintf(systray,"1\n");
		else fprintf(systray,"0\n");
		if (go_identify== TRUE) fprintf(systray,"1\n");
		else fprintf(systray,"0\n");
		if (highlight== TRUE) fprintf(systray,"1\n");
		else fprintf(systray,"0\n");
		if (query== TRUE) fprintf(systray,"1\n");
		else fprintf(systray,"0\n");
		if (disconnection== TRUE) fprintf(systray,"1\n");
		else fprintf(systray,"0\n");
		if (kill== TRUE) fprintf(systray,"1\n");
		else fprintf(systray,"0\n");
		if (kick== TRUE) fprintf(systray,"1\n");
		else fprintf(systray,"0\n");
		if (dcc_chat== TRUE) fprintf(systray,"1\n");
		else fprintf(systray,"0\n");
		if (dcc_send== TRUE) fprintf(systray,"1\n");
		else fprintf(systray,"0\n");
		if (invite== TRUE) fprintf(systray,"1\n");
		else fprintf(systray,"0\n");
		if (notify_list== TRUE) fprintf(systray,"1\n");
		else fprintf(systray,"0\n");
		fprintf(systray,"%d\n",flash_interval);

		if (control) xchat_printf(ph,"Successfully saved settings to file.\n");
		fclose(systray);
	} else {
		xchat_printf(ph,"Error writing to file %s.\n", path);
	}
}

//get apps path & settings
static void get_info (gboolean onstart_warning,gboolean control) {
	FILE *systray;
	char path[150];
	int len,check;
	sprintf(path,"%s/systray.conf", xchat_get_info(ph, "xchatdir"));
	systray = fopen(path,"r");
	if (systray != NULL) {
		//cut off the "\n" value
		fgets(bpath,150,systray);
		len=strlen(bpath); if ( len && bpath[len-1] == '\n' ) bpath[len-1] = 0;
		fgets(epath,150,systray);
		len=strlen(epath); if ( len && epath[len-1] == '\n' ) epath[len-1] = 0;
		fgets(ppath,150,systray);
		len=strlen(ppath); if ( len && ppath[len-1] == '\n' ) ppath[len-1] = 0;
		fgets(away_msg1,150,systray);
		len=strlen(away_msg1); if ( len && away_msg1[len-1] == '\n' ) away_msg1[len-1] = 0;
		fgets(away_msg2,150,systray);
		len=strlen(away_msg2); if ( len && away_msg2[len-1] == '\n' ) away_msg2[len-1] = 0;
		fgets(away_msg3,150,systray);
		len=strlen(away_msg3); if ( len && away_msg3[len-1] == '\n' ) away_msg3[len-1] = 0;
		fgets(away_nick,150,systray);
		len=strlen(away_nick); if ( len && away_nick[len-1] == '\n' ) away_nick[len-1] = 0;
		fgets(away_pass,150,systray);
		len=strlen(away_pass); if ( len && away_pass[len-1] == '\n' ) away_pass[len-1] = 0;

		fscanf(systray,"%d",&check);
		if ( check== 1 ) KDE=TRUE;
		else KDE=FALSE;

		fscanf(systray,"%d",&check);
		if ( check== 1 ) go_change=TRUE;
		else go_change=FALSE;

		fscanf(systray,"%d",&check);
		if ( check== 1 ) go_identify=TRUE;
		else go_identify=FALSE;

		fscanf(systray,"%d",&check);
		if ( check== 1 ) highlight=TRUE;
		else highlight=FALSE;

		fscanf(systray,"%d",&check);
		if ( check== 1 ) query=TRUE;
		else query=FALSE;

		fscanf(systray,"%d",&check);
		if ( check== 1 ) disconnection=TRUE;
		else disconnection=FALSE;

		fscanf(systray,"%d",&check);
		if ( check== 1 ) kill=TRUE;
		else kill=FALSE;

		fscanf(systray,"%d",&check);
		if ( check== 1 ) kick=TRUE;
		else kick=FALSE;

		fscanf(systray,"%d",&check);
		if ( check== 1 ) dcc_chat=TRUE;
		else dcc_chat=FALSE;

		fscanf(systray,"%d",&check);
		if ( check== 1 ) dcc_send=TRUE;
		else dcc_send=FALSE;

		fscanf(systray,"%d",&check);
		if ( check== 1 ) invite=TRUE;
		else invite=FALSE;

		fscanf(systray,"%d",&check);
		if ( check== 1 ) notify_list=TRUE;
		else notify_list=FALSE;

		fscanf(systray,"%d",&check);
		flash_interval=check;

		if (control) xchat_printf(ph,"Successfully loaded settings from file.\n");
		fclose(systray);
	}
	else if (onstart_warning) {
			xchat_printf(ph,"Error opening file %s.\n", path);
			show_warning();
		}


}

// calls saving function and updates variables
void save(){

	if (window_manager_modified!=KDE) show_win_manager_warning();

	xchat_printf(ph, "These are your selected application paths & settings:\n");
	bpath1= gtk_entry_get_text( GTK_ENTRY(browser_text) );
	xchat_printf(ph, "Browser: %s",bpath1);
	epath1= gtk_entry_get_text( GTK_ENTRY(email_text) );
	xchat_printf(ph, "Email Client: %s",epath1);
	ppath1= gtk_entry_get_text( GTK_ENTRY(player_text) );
	xchat_printf(ph, "Multimedia Player: %s",ppath1);
	amsg1= gtk_entry_get_text( GTK_ENTRY(away1) );
	xchat_printf(ph, "Your first favourite away message: %s",amsg1);
	amsg2= gtk_entry_get_text( GTK_ENTRY(away2) );
	xchat_printf(ph, "Your second favourite away message: %s",amsg2);
	amsg3= gtk_entry_get_text( GTK_ENTRY(away3) );
	xchat_printf(ph, "Your third favourite away message: %s",amsg3);
	awaynick=gtk_entry_get_text( GTK_ENTRY(away_nick_box) );
	awaypass=gtk_entry_get_text( GTK_ENTRY(away_nick_pass_box) );
	if (go_change==TRUE) {
		xchat_printf(ph, "While in away, you want to change your nick in: %s",awaynick);
		if ( go_identify == TRUE ) {

			xchat_printf(ph, "Your away nick password is: %s",awaypass);
		}
		else xchat_printf(ph, "Your away nick doesn't need to be identified.");
	}
	else xchat_printf(ph, "While in away, you don't want to change your nick.");
	if (highlight==TRUE) xchat_printf(ph, "HighLight Messages Event Notification: on"); else xchat_printf(ph, "HighLight Messages Event Notification: off");
	if (query==TRUE) xchat_printf(ph, "Query Event Notification: on"); else xchat_printf(ph, "Query Event Notification: off");
	if (disconnection==TRUE) xchat_printf(ph, "Disconnection Event Notification: on"); else xchat_printf(ph, "Disconnection Event Notification: off");
	if (kill==TRUE) xchat_printf(ph, "Kill Event Notification: on"); else xchat_printf(ph, "Kill Event Notification: off");
	if (kick==TRUE) xchat_printf(ph, "Kick Event Notification: on"); else xchat_printf(ph, "Kick Event Notification: off");
	if (dcc_chat==TRUE) xchat_printf(ph, "DCC Chat Event Notification: on"); else xchat_printf(ph, "DCC Chat Event Notification: off");
	if (dcc_send==TRUE) xchat_printf(ph, "DCC Send Event Notification: on"); else xchat_printf(ph, "DCC Send Event Notification: off");
	if (invite==TRUE) xchat_printf(ph, "Invite Event Notification: on"); else xchat_printf(ph, "Invite Event Notification: off");
	if (notify_list==TRUE) xchat_printf(ph, "Notify List Event Notification: on"); else xchat_printf(ph, "Notify List Event Notification: off");

	xchat_printf(ph, "Selected Tray Flashing Timeout: %d",flash_interval);
	if (KDE) xchat_printf(ph,"Your Window Manager has KDE like style");
	else xchat_printf(ph,"Your Window Manager has Gnome like style");
	xchat_print(ph, "\nIf you want to change settings, please select Settings again.");
	write2file(TRUE);
	get_info(FALSE,FALSE);
}

//CHOOSE APPS PATH

//file selected
void ok_click( GtkWidget *w, GtkFileSelection *fs )
{
    gtk_entry_set_text(GTK_ENTRY(*app2set), gtk_file_selection_get_filename (GTK_FILE_SELECTION (fs)));

    gtk_widget_destroy(GTK_WIDGET(fs));
}

//file selection gui
void app_select()
{

    GtkWidget *filew;

    filew = gtk_file_selection_new ("Select the right path");
    gtk_file_selection_set_filename (GTK_FILE_SELECTION(filew),"");

    g_signal_connect (G_OBJECT (GTK_FILE_SELECTION (filew)->ok_button),
                      "clicked", G_CALLBACK (ok_click), (gpointer) filew);

    g_signal_connect_swapped (G_OBJECT (GTK_FILE_SELECTION (filew)->cancel_button),
                              "clicked", G_CALLBACK (gtk_widget_destroy),
                              G_OBJECT (filew));

    gtk_widget_show (filew);

}

//browser popup gui
void browser_select() {
	app2set=&browser_text;
	app_select();

}

//email client popup gui
void email_select() {

    app2set=&email_text;
	app_select();

}

//multimedia player popup gui
void player_select() {

	app2set=&player_text;
	app_select();

}

// SETTINGS GUI

//delete setting window and reload real values.
static void set_tray_delete() {

	get_info(FALSE,FALSE);

}


static void high_use_yes() {

	highlight=TRUE;

}

static void high_use_not() {

	highlight=FALSE;

}

static void query_use_yes() {

	query=TRUE;

}

static void query_use_not() {

	query=FALSE;

}

static void kill_use_yes() {

	kill=TRUE;
}

static void kill_use_not() {

	kill=FALSE;
}

static void disc_use_yes() {

	disconnection=TRUE;
}

static void disc_use_not() {

	disconnection=FALSE;
}

static void dcc_chat_use_yes() {

	dcc_chat=TRUE;
}

static void dcc_chat_use_not() {

	dcc_chat=FALSE;
}

static void kick_use_yes() {

	kick=TRUE;
}

static void kick_use_not() {

	kick=FALSE;
}

static void dcc_send_use_yes() {

	dcc_send=TRUE;
}

static void dcc_send_use_not() {

	dcc_send=FALSE;
}

static void invite_use_yes() {

	invite=TRUE;
}

static void invite_use_not() {

	invite=FALSE;
}

static void notify_use_yes() {

	notify_list=TRUE;
}

static void notify_use_not() {

	notify_list=FALSE;
}

static void set_noti_events_apply() {

	flash_interval=gtk_spin_button_get_value_as_int(GTK_SPIN_BUTTON(spinbutton));
	write2file(FALSE);
	get_info(FALSE,FALSE);

}

static void kde_use_yes() {
	KDE=TRUE;
}

static void kde_use_not() {
	KDE=FALSE;
}

//events notification selection
static void set_noti_events(){

	GtkWidget *window;
	GtkWidget *checkbut,*checkbut1;
	GtkWidget *table;
	GtkWidget *button,*box1,*box2,*box3,*box4,*box5,*box6,*box7,*box8,*box9,*box10,*box11;
	GtkWidget *label;
	GSList *group;
	GtkAdjustment *adj;

	get_info(FALSE,FALSE);

	//create box and window
	window = gtk_window_new (GTK_WINDOW_TOPLEVEL);
	gtk_window_set_resizable(GTK_WINDOW (window),FALSE);
	gtk_window_set_title (GTK_WINDOW (window), "Notification Events Selection");
	gtk_container_set_border_width (GTK_CONTAINER (window), 10);

	table=gtk_table_new(14,3,FALSE);
	gtk_table_set_col_spacings(GTK_TABLE(table), 40 );
	gtk_table_set_row_spacings(GTK_TABLE(table), 12 );
	gtk_container_add (GTK_CONTAINER (window), table);

	box1 = gtk_hbox_new (FALSE, 40);
	box2 = gtk_hbox_new (FALSE, 40);
	box3 = gtk_hbox_new (FALSE, 40);
	box4 = gtk_hbox_new (FALSE, 40);
	box5 = gtk_hbox_new (FALSE, 40);
	box6 = gtk_hbox_new (FALSE, 40);
	box7 = gtk_hbox_new (FALSE, 40);
	box8 = gtk_hbox_new (FALSE, 40);
	box9 = gtk_hbox_new (FALSE, 40);
	box10 = gtk_hbox_new (FALSE, 40);
	box11 = gtk_hbox_new (FALSE, 40);

	label = gtk_label_new ("Notification Events Selection. Select your favorite events.");
	gtk_table_attach_defaults(GTK_TABLE(table),label,0,2,0,1);
  	gtk_widget_show (label);

	//Hilighted Msg
	gtk_table_attach_defaults(GTK_TABLE(table),box1,1,2,2,3);

	label = gtk_label_new ("HighLighted Message");
	gtk_table_attach_defaults(GTK_TABLE(table),label,0,1,2,3);
    	gtk_widget_show (label);

	checkbut = gtk_radio_button_new_with_label (NULL, "yes");
	g_signal_connect (G_OBJECT (checkbut), "toggled", G_CALLBACK (high_use_yes),G_OBJECT (checkbut));
	gtk_box_pack_start (GTK_BOX (box1), checkbut, FALSE, FALSE, 15);
 	gtk_widget_show (checkbut);
	if(highlight) gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (checkbut), TRUE);
	else gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (checkbut), FALSE);

 	group = gtk_radio_button_get_group (GTK_RADIO_BUTTON (checkbut));
  	checkbut1 = gtk_radio_button_new_with_label (group, "no");
	g_signal_connect (G_OBJECT (checkbut1), "toggled", G_CALLBACK (high_use_not),G_OBJECT (checkbut1));
  	gtk_box_pack_start (GTK_BOX (box1), checkbut1, FALSE, FALSE, 15);
  	gtk_widget_show (checkbut1);
	gtk_widget_show (box1);
	if(!highlight) gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (checkbut1), TRUE);
	else gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (checkbut1), FALSE);

	//Query
	gtk_table_attach_defaults(GTK_TABLE(table),box2,1,3,3,4);

	label = gtk_label_new ("Query (private message)");
	gtk_table_attach_defaults(GTK_TABLE(table),label,0,1,3,4);
    	gtk_widget_show (label);

	checkbut = gtk_radio_button_new_with_label (NULL, "yes");
	g_signal_connect (G_OBJECT (checkbut), "toggled", G_CALLBACK (query_use_yes),G_OBJECT (checkbut));
   	gtk_box_pack_start (GTK_BOX (box2), checkbut, FALSE, FALSE, 15);
 	gtk_widget_show (checkbut);
	if (query) gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (checkbut), TRUE);
	else gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (checkbut), FALSE);

 	group = gtk_radio_button_get_group (GTK_RADIO_BUTTON (checkbut));
  	checkbut1 = gtk_radio_button_new_with_label (group, "no");
	g_signal_connect (G_OBJECT (checkbut1), "toggled", G_CALLBACK (query_use_not),G_OBJECT (checkbut1));
	gtk_box_pack_start (GTK_BOX (box2), checkbut1, FALSE, FALSE, 15);
  	gtk_widget_show (checkbut1);
	gtk_widget_show(box2);
	if(!query) gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (checkbut1), TRUE);
	else gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (checkbut1), FALSE);

	// Disconnection from servers
	gtk_table_attach_defaults(GTK_TABLE(table),box3,1,3,4,5);

	label = gtk_label_new ("Disconnection");
	gtk_table_attach_defaults(GTK_TABLE(table),label,0,1,4,5);
    	gtk_widget_show (label);

	checkbut = gtk_radio_button_new_with_label (NULL, "yes");
   	g_signal_connect (G_OBJECT (checkbut), "toggled", G_CALLBACK (disc_use_yes),G_OBJECT (checkbut));
   	gtk_box_pack_start (GTK_BOX (box3), checkbut, FALSE, FALSE, 15);
 	gtk_widget_show (checkbut);
	if(disconnection) gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (checkbut), TRUE);
	else gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (checkbut), FALSE);

 	group = gtk_radio_button_get_group (GTK_RADIO_BUTTON (checkbut));
  	checkbut1 = gtk_radio_button_new_with_label (group, "no");
	g_signal_connect (G_OBJECT (checkbut1), "toggled", G_CALLBACK (disc_use_not),G_OBJECT (checkbut1));
  	gtk_box_pack_start (GTK_BOX (box3), checkbut1, FALSE, FALSE, 15);
  	gtk_widget_show (checkbut1);
	gtk_widget_show(box3);
	if(!disconnection) gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (checkbut1), TRUE);
	else gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (checkbut1), FALSE);

	//killed
	gtk_table_attach_defaults(GTK_TABLE(table),box4,1,3,5,6);

	label = gtk_label_new ("Kill");
	gtk_table_attach_defaults(GTK_TABLE(table),label,0,1,5,6);
    	gtk_widget_show (label);

	checkbut= gtk_radio_button_new_with_label (NULL, "yes");
	g_signal_connect (G_OBJECT (checkbut), "toggled", G_CALLBACK (kill_use_yes),G_OBJECT (checkbut));
   	gtk_box_pack_start (GTK_BOX (box4), checkbut, FALSE, FALSE, 15);
 	gtk_widget_show (checkbut);
	if (kill) gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (checkbut), TRUE);
	else gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (checkbut), FALSE);

 	group = gtk_radio_button_get_group (GTK_RADIO_BUTTON (checkbut));
  	checkbut1 = gtk_radio_button_new_with_label (group, "no");
	g_signal_connect (G_OBJECT (checkbut1), "toggled", G_CALLBACK (kill_use_not),G_OBJECT (checkbut1));
  	gtk_box_pack_start (GTK_BOX (box4), checkbut1, FALSE, FALSE, 15);
  	gtk_widget_show (checkbut1);
	gtk_widget_show(box4);
	if(!kill) gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (checkbut1), TRUE);
	else gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (checkbut1), FALSE);

	//Kick & ban
	label = gtk_label_new ("Kick (& Ban)");
	gtk_table_attach_defaults(GTK_TABLE(table),label,0,1,6,7);
    	gtk_widget_show (label);

	gtk_table_attach_defaults(GTK_TABLE(table),box5,1,3,6,7);

	checkbut = gtk_radio_button_new_with_label (NULL, "yes");
	g_signal_connect (G_OBJECT (checkbut), "toggled", G_CALLBACK (kick_use_yes),G_OBJECT (checkbut));
   	gtk_box_pack_start (GTK_BOX (box5), checkbut, FALSE, FALSE, 15);
 	gtk_widget_show (checkbut);
	if (kick) gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (checkbut), TRUE);
	else gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (checkbut), FALSE);

 	group = gtk_radio_button_get_group (GTK_RADIO_BUTTON (checkbut));
  	checkbut1 = gtk_radio_button_new_with_label (group, "no");
	g_signal_connect (G_OBJECT (checkbut1), "toggled", G_CALLBACK (kick_use_not),G_OBJECT (checkbut1));
  	gtk_box_pack_start (GTK_BOX (box5), checkbut1, FALSE, FALSE, 15);
  	gtk_widget_show (checkbut1);
	gtk_widget_show(box5);
	if(!kick) gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (checkbut1), TRUE);
	else gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (checkbut1), FALSE);

	//DCC Chat
	gtk_table_attach_defaults(GTK_TABLE(table),box6,1,3,7,8);

	label = gtk_label_new ("DCC Chat");
	gtk_table_attach_defaults(GTK_TABLE(table),label,0,1,7,8);
    	gtk_widget_show (label);

	checkbut = gtk_radio_button_new_with_label (NULL, "yes");
	g_signal_connect (G_OBJECT (checkbut), "toggled", G_CALLBACK (dcc_chat_use_yes),G_OBJECT (checkbut));
   	gtk_box_pack_start (GTK_BOX (box6), checkbut, FALSE, FALSE, 15);
 	gtk_widget_show (checkbut);
	if (dcc_chat) gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (checkbut), TRUE);
	else gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (checkbut), FALSE);

 	group = gtk_radio_button_get_group (GTK_RADIO_BUTTON (checkbut));
  	checkbut1 = gtk_radio_button_new_with_label (group, "no");
	if(!dcc_chat) gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (checkbut1), TRUE);
	else gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (checkbut1), FALSE);
 	g_signal_connect (G_OBJECT (checkbut1), "toggled", G_CALLBACK (dcc_chat_use_not),G_OBJECT (checkbut1));
  	gtk_box_pack_start (GTK_BOX (box6), checkbut1, FALSE, FALSE, 15);
  	gtk_widget_show (checkbut1);
	gtk_widget_show(box6);

	//DCC Send
	gtk_table_attach_defaults(GTK_TABLE(table),box7,1,3,8,9);

	label = gtk_label_new ("DCC send");
	gtk_table_attach_defaults(GTK_TABLE(table),label,0,1,8,9);
    	gtk_widget_show (label);

	checkbut = gtk_radio_button_new_with_label (NULL, "yes");
	g_signal_connect (G_OBJECT (checkbut), "toggled", G_CALLBACK (dcc_send_use_yes),G_OBJECT (checkbut));
   	gtk_box_pack_start (GTK_BOX (box7), checkbut, FALSE, FALSE, 15);
 	gtk_widget_show (checkbut);
	if (dcc_send) gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (checkbut), TRUE);
	else gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (checkbut), FALSE);

 	group = gtk_radio_button_get_group (GTK_RADIO_BUTTON (checkbut));
  	checkbut1 = gtk_radio_button_new_with_label (group, "no");
	g_signal_connect (G_OBJECT (checkbut1), "toggled", G_CALLBACK (dcc_send_use_not),G_OBJECT (checkbut1));
  	gtk_box_pack_start (GTK_BOX (box7), checkbut1, FALSE, FALSE, 15);
  	gtk_widget_show (checkbut1);
	gtk_widget_show(box7);
	if(!dcc_send) gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (checkbut1), TRUE);
	else gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (checkbut1), FALSE);

	//Invite
	gtk_table_attach_defaults(GTK_TABLE(table),box8,1,3,9,10);

	label = gtk_label_new ("Invite");
	gtk_table_attach_defaults(GTK_TABLE(table),label,0,1,9,10);
    	gtk_widget_show (label);

	checkbut = gtk_radio_button_new_with_label (NULL, "yes");
   	g_signal_connect (G_OBJECT (checkbut), "toggled", G_CALLBACK (invite_use_yes),G_OBJECT (checkbut));
   	gtk_box_pack_start (GTK_BOX (box8), checkbut, FALSE, FALSE, 15);
 	gtk_widget_show (checkbut);
	if (invite) gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (checkbut), TRUE);
	else gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (checkbut), FALSE);

 	group = gtk_radio_button_get_group (GTK_RADIO_BUTTON (checkbut));
  	checkbut = gtk_radio_button_new_with_label (group, "no");
	g_signal_connect (G_OBJECT (checkbut), "toggled", G_CALLBACK (invite_use_not),G_OBJECT (checkbut));
  	gtk_box_pack_start (GTK_BOX (box8), checkbut, FALSE, FALSE, 15);
  	gtk_widget_show (checkbut);
	gtk_widget_show(box8);
	if(!invite) gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (checkbut), TRUE);
	else gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (checkbut), FALSE);

	//Notify list
	gtk_table_attach_defaults(GTK_TABLE(table),box9,1,3,10,11);

	label = gtk_label_new ("Notify List");
	gtk_table_attach_defaults(GTK_TABLE(table),label,0,1,10,11);
    	gtk_widget_show (label);

	checkbut = gtk_radio_button_new_with_label (NULL, "yes");
   	g_signal_connect (G_OBJECT (checkbut), "toggled", G_CALLBACK (notify_use_yes),G_OBJECT (checkbut));
   	gtk_box_pack_start (GTK_BOX (box9), checkbut, FALSE, FALSE, 15);
 	gtk_widget_show (checkbut);
	if(notify_list) gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (checkbut), TRUE);
	else gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (checkbut), FALSE);

 	group = gtk_radio_button_get_group (GTK_RADIO_BUTTON (checkbut));
  	checkbut = gtk_radio_button_new_with_label (group, "no");
 	g_signal_connect (G_OBJECT (checkbut), "toggled", G_CALLBACK (notify_use_not),G_OBJECT (checkbut));
  	gtk_box_pack_start (GTK_BOX (box9), checkbut, FALSE, FALSE, 15);
  	gtk_widget_show (checkbut);
	gtk_widget_show(box9);
	if(!notify_list) gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (checkbut), TRUE);
	else gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (checkbut), FALSE);

	//flash interval
	gtk_table_attach_defaults(GTK_TABLE(table),box10,1,3,11,12);

	label = gtk_label_new ("Select Tray Flash Timeout (msec)");
	gtk_table_attach_defaults(GTK_TABLE(table),label,0,1,11,12);
    	gtk_widget_show (label);

	adj = (GtkAdjustment *) gtk_adjustment_new (500, 200, 2000, 100, 0, 0);
	spinbutton = gtk_spin_button_new (adj, 0, 0);
  	gtk_spin_button_set_wrap (GTK_SPIN_BUTTON (spinbutton), FALSE);
	gtk_spin_button_set_numeric(GTK_SPIN_BUTTON (spinbutton), TRUE);
	gtk_spin_button_set_value(GTK_SPIN_BUTTON (spinbutton), flash_interval);
	gtk_box_pack_start (GTK_BOX (box10), spinbutton, FALSE, TRUE, 15);
	gtk_widget_show (spinbutton);
	gtk_widget_show (box10);

	//4-5 button
	gtk_table_attach_defaults(GTK_TABLE(table),box11,0,3,12,13);

	button = gtk_button_new_with_label ("Apply");
   	g_signal_connect (G_OBJECT (button), "clicked", G_CALLBACK (set_noti_events_apply), NULL);
    	gtk_box_pack_start (GTK_BOX (box11), button, FALSE, FALSE, 100);
    	gtk_widget_show (button);

	button = gtk_button_new_with_label ("Close");
	g_signal_connect (G_OBJECT (button), "clicked", G_CALLBACK (set_tray_delete), NULL);
	g_signal_connect (G_OBJECT (window), "delete_event", G_CALLBACK (set_tray_delete), G_OBJECT (window));
	g_signal_connect (G_OBJECT (window), "destroy", G_CALLBACK (set_tray_delete), G_OBJECT (window));
	g_signal_connect_swapped (G_OBJECT (button), "clicked",G_CALLBACK (gtk_widget_destroy),G_OBJECT (window));
    	gtk_box_pack_start (GTK_BOX (box11), button, FALSE, FALSE, 75);
    	gtk_widget_show (button);
	gtk_widget_show (box11);

	gtk_widget_show(table);
 	gtk_widget_show (window);

}

//settings gui
void set_tray(){

	GtkWidget *window;
	GtkWidget *table;
	GtkWidget *checkbutton,*checkbutton2,*checkbutton4,*checkbutton5;
	GtkWidget *button,*box1,*box2,*box3,*box4;
	GtkWidget *label;
	GSList *group;

	get_info(FALSE,FALSE);

	//create box and window
	window = gtk_window_new (GTK_WINDOW_TOPLEVEL);
	gtk_window_set_resizable(GTK_WINDOW (window),FALSE);
	gtk_window_set_title (GTK_WINDOW (window), "SysTray Settings");
	gtk_container_set_border_width (GTK_CONTAINER (window), 10);

	table=gtk_table_new(14,3,FALSE);
	gtk_table_set_col_spacings(GTK_TABLE(table), 40 );
	gtk_table_set_row_spacings(GTK_TABLE(table), 12 );
	gtk_container_add (GTK_CONTAINER (window), table);

	box1 = gtk_hbox_new (FALSE, 40);
	box2 = gtk_hbox_new (FALSE, 40);
	box3 = gtk_hbox_new (FALSE, 40);
	box4 = gtk_hbox_new (FALSE, 60);

	label = gtk_label_new ("SysTray Settings. Select your favorite apps and settings");
	gtk_table_attach_defaults(GTK_TABLE(table),label,0,2,0,1);
  	gtk_widget_show (label);

	//1 button
	label = gtk_label_new ("Select your favorite browser");
	gtk_table_attach_defaults(GTK_TABLE(table),label,0,1,1,2);
	gtk_widget_show (label);

	browser_text = gtk_entry_new ();
	gtk_table_attach_defaults(GTK_TABLE(table),browser_text,1,2,1,2);
	gtk_entry_set_max_length(GTK_ENTRY(browser_text), 150);
	gtk_entry_set_text(GTK_ENTRY(browser_text), bpath);
    	gtk_widget_show (browser_text);

	button = gtk_button_new_with_label ("Select");
	gtk_table_attach_defaults(GTK_TABLE(table),button,2,3,1,2);
   	g_signal_connect (G_OBJECT (button), "clicked", G_CALLBACK (browser_select), NULL);
    	gtk_widget_show (button);

	//2 button
    	label = gtk_label_new ("Select your favorite email client");
	gtk_table_attach_defaults(GTK_TABLE(table),label,0,1,2,3);
 	gtk_widget_show (label);

	email_text = gtk_entry_new ();
	gtk_entry_set_max_length(GTK_ENTRY(email_text), 150);
	gtk_entry_set_text(GTK_ENTRY(email_text), epath);
	gtk_table_attach_defaults(GTK_TABLE(table),email_text,1,2,2,3);
 	gtk_widget_show (email_text);

	button = gtk_button_new_with_label ("Select");
   	g_signal_connect (G_OBJECT (button), "clicked", G_CALLBACK (email_select), NULL);
	gtk_table_attach_defaults(GTK_TABLE(table),button,2,3,2,3);
    	gtk_widget_show (button);

	//3 button
	label = gtk_label_new ("Select your favorite multimedia player	");
	gtk_table_attach_defaults(GTK_TABLE(table),label,0,1,3,4);
    	gtk_widget_show (label);

	player_text = gtk_entry_new ();
	gtk_entry_set_max_length(GTK_ENTRY(player_text), 150);
	gtk_entry_set_text(GTK_ENTRY(player_text), ppath);
	gtk_table_attach_defaults(GTK_TABLE(table),player_text,1,2,3,4);
    	gtk_widget_show (player_text);

	button = gtk_button_new_with_label ("Select");
   	g_signal_connect (G_OBJECT (button), "clicked", G_CALLBACK (player_select), NULL);
	gtk_table_attach_defaults(GTK_TABLE(table),button,2,3,3,4);
    	gtk_widget_show (button);

	//away msg n1
	label = gtk_label_new ("Write your first favourite away message	");
	gtk_table_attach_defaults(GTK_TABLE(table),label,0,1,4,5);
    	gtk_widget_show (label);

	away1 = gtk_entry_new ();
	gtk_entry_set_max_length(GTK_ENTRY(away1), 150);
	gtk_entry_set_text(GTK_ENTRY(away1), away_msg1);
	gtk_table_attach_defaults(GTK_TABLE(table),away1,1,3,4,5);
    	gtk_widget_show (away1);

	//away msg n2
	label = gtk_label_new ("Write your second favourite away message");
	gtk_table_attach_defaults(GTK_TABLE(table),label,0,1,5,6);
    	gtk_widget_show (label);

	away2 = gtk_entry_new ();
	gtk_entry_set_max_length(GTK_ENTRY(away2), 150);
	gtk_entry_set_text(GTK_ENTRY(away2), away_msg2);
	gtk_table_attach_defaults(GTK_TABLE(table),away2,1,3,5,6);
    	gtk_widget_show (away2);

	//away msg n3
	label = gtk_label_new ("Write your third favourite away message	");
	gtk_table_attach_defaults(GTK_TABLE(table),label,0,1,6,7);
    	gtk_widget_show (label);

	away3 = gtk_entry_new ();
	gtk_entry_set_max_length(GTK_ENTRY(away3), 150);
	gtk_entry_set_text(GTK_ENTRY(away3), away_msg3);
	gtk_table_attach_defaults(GTK_TABLE(table),away3,1,3,6,7);
    	gtk_widget_show (away3);

	label = gtk_label_new ("Change Nick while away?");
	gtk_table_attach_defaults(GTK_TABLE(table),label,0,1,7,8);
    	gtk_widget_show (label);

	gtk_table_attach_defaults(GTK_TABLE(table),box1,1,2,7,8);

	checkbutton = gtk_radio_button_new_with_label (NULL, "yes");
	gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (checkbutton), FALSE);
   	g_signal_connect (G_OBJECT (checkbutton), "toggled", G_CALLBACK (away_use_yes),G_OBJECT (checkbutton));
	gtk_box_pack_start (GTK_BOX (box1), checkbutton, FALSE, FALSE, 15);
 	gtk_widget_show (checkbutton);

 	group = gtk_radio_button_get_group (GTK_RADIO_BUTTON (checkbutton));
  	checkbutton = gtk_radio_button_new_with_label (group, "no");
	if ( go_change == FALSE) gtk_button_clicked (GTK_BUTTON(checkbutton));
	g_signal_connect (G_OBJECT (checkbutton), "toggled", G_CALLBACK (away_use_not),G_OBJECT (checkbutton));
	gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (checkbutton), FALSE);
  	gtk_box_pack_start (GTK_BOX (box1), checkbutton, FALSE, FALSE, 15);
  	gtk_widget_show (checkbutton);
	gtk_widget_show (box1);

	label = gtk_label_new ("Enter your away nickname");
	gtk_table_attach_defaults(GTK_TABLE(table),label,0,1,8,9);
    	gtk_widget_show (label);

	away_nick_box = gtk_entry_new ();
	gtk_entry_set_max_length(GTK_ENTRY(away_nick_box), 150);
	gtk_entry_set_text(GTK_ENTRY(away_nick_box), away_nick);
	gtk_table_attach_defaults(GTK_TABLE(table),away_nick_box,1,3,8,9);
 	gtk_widget_show (away_nick_box);

	label = gtk_label_new ("Away nick needs to be identified?");
	gtk_table_attach_defaults(GTK_TABLE(table),label,0,1,9,10);
    	gtk_widget_show (label);

	gtk_table_attach_defaults(GTK_TABLE(table),box2,1,3,9,10);

	checkbutton2 = gtk_radio_button_new_with_label (NULL, "yes");
	gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (checkbutton2), FALSE);
	g_signal_connect (G_OBJECT (checkbutton2), "toggled", G_CALLBACK (away_ident_yes),G_OBJECT (checkbutton2));
   	gtk_box_pack_start (GTK_BOX (box2), checkbutton2, FALSE, FALSE, 15);
 	gtk_widget_show (checkbutton2);

 	group = gtk_radio_button_get_group (GTK_RADIO_BUTTON (checkbutton2));
  	checkbutton3 = gtk_radio_button_new_with_label (group, "no");
	if ( go_identify == FALSE) gtk_button_clicked (GTK_BUTTON(checkbutton3));
	gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (checkbutton3), FALSE);
	g_signal_connect (G_OBJECT (checkbutton3), "toggled", G_CALLBACK (away_ident_not),G_OBJECT (checkbutton3));
  	gtk_box_pack_start (GTK_BOX (box2), checkbutton3, FALSE, FALSE, 15);
  	gtk_widget_show (checkbutton3);
	gtk_widget_show(box2);

	label = gtk_label_new ("Enter your away nickname password");
 	gtk_table_attach_defaults(GTK_TABLE(table),label,0,1,10,11);
    	gtk_widget_show (label);

	away_nick_pass_box = gtk_entry_new ();
	gtk_entry_set_max_length(GTK_ENTRY(away_nick_pass_box), 150);
	gtk_entry_set_visibility(GTK_ENTRY(away_nick_pass_box), FALSE);
	gtk_entry_set_text(GTK_ENTRY(away_nick_pass_box), away_pass);
	gtk_table_attach_defaults(GTK_TABLE(table),away_nick_pass_box,1,3,10,11);
 	gtk_widget_show (away_nick_pass_box);

	// open a new tab
	label = gtk_label_new ("Select Notification Events");
 	gtk_table_attach_defaults(GTK_TABLE(table),label,0,1,11,12);
	gtk_widget_show (label);

	button = gtk_button_new_with_label ("Select Events");
   	g_signal_connect (G_OBJECT (button), "clicked", G_CALLBACK (set_noti_events), NULL);
    	gtk_table_attach_defaults(GTK_TABLE(table),button,1,2,11,12);
    	gtk_widget_show (button);

	//window desktop choice
	label = gtk_label_new ("Select Your Window Manager");
 	gtk_table_attach_defaults(GTK_TABLE(table),label,0,1,12,13);
	gtk_widget_show (label);

	gtk_table_attach_defaults(GTK_TABLE(table),box3,1,3,12,13);

	checkbutton4 = gtk_radio_button_new_with_label (NULL, "KDE Like");
	g_signal_connect (G_OBJECT (checkbutton4), "toggled", G_CALLBACK (kde_use_yes),G_OBJECT (checkbutton4));
   	gtk_box_pack_start (GTK_BOX (box3), checkbutton4, FALSE, FALSE, 15);
 	gtk_widget_show (checkbutton4);

 	group = gtk_radio_button_get_group (GTK_RADIO_BUTTON (checkbutton4));
  	checkbutton5 = gtk_radio_button_new_with_label (group, "Gnome Like");
	g_signal_connect (G_OBJECT (checkbutton5), "toggled", G_CALLBACK (kde_use_not),G_OBJECT (checkbutton5));
  	gtk_box_pack_start (GTK_BOX (box3), checkbutton5, FALSE, FALSE, 15);
  	gtk_widget_show (checkbutton5);
	gtk_widget_show(box3);

	if ( KDE == TRUE) gtk_button_clicked (GTK_BUTTON(checkbutton4));
	else gtk_button_clicked (GTK_BUTTON(checkbutton5));

	//4-5 button
	gtk_table_attach_defaults(GTK_TABLE(table),box4,0,3,14,15);

	button = gtk_button_new_with_label ("Apply");
   	g_signal_connect (G_OBJECT (button), "clicked", G_CALLBACK (save), NULL);
    	gtk_box_pack_start (GTK_BOX (box4), button, FALSE, FALSE, 120);
    	gtk_widget_show (button);

	button = gtk_button_new_with_label ("Close");
	g_signal_connect (G_OBJECT (button), "clicked", G_CALLBACK (set_tray_delete), NULL);
	g_signal_connect (G_OBJECT (window), "delete_event", G_CALLBACK (set_tray_delete), G_OBJECT (window));
	g_signal_connect (G_OBJECT (window), "destroy", G_CALLBACK (set_tray_delete), G_OBJECT (window));
	g_signal_connect_swapped (G_OBJECT (button), "clicked",G_CALLBACK (gtk_widget_destroy),G_OBJECT (window));
    	gtk_box_pack_start (GTK_BOX (box4), button, FALSE, FALSE, 47);
    	gtk_widget_show (button);
	gtk_widget_show (box4);

	if ( go_change == FALSE) away_use_not(checkbutton, NULL);
	if ( go_identify == FALSE) away_ident_not(checkbutton3, NULL);

	gtk_widget_show(table);
 	gtk_widget_show (window);

}

//AWAY SYSTEM

//get the select away msg
void get_label(GtkWidget *button, void *data) {

	if (gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON(button)) ) {
		gtk_entry_set_text(GTK_ENTRY(away_text), gtk_button_get_label(GTK_BUTTON(button)));
	}
}

//if you choose to change nick while away
static void away_use_yes(GtkWidget *button, void *data) {

	if (gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON(button)) ) {
		go_change=TRUE;
		gtk_editable_set_editable(GTK_EDITABLE(away_nick_box), TRUE);
		gtk_entry_set_text(GTK_ENTRY(away_nick_box), "");
		edit=TRUE;
	}

}

//if you do not choose to change nick while away
static void away_use_not(GtkWidget *button, void *data) {

	if (gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON(button)) ) {
			go_change=FALSE;
			go_identify=FALSE;
			gtk_entry_set_text(GTK_ENTRY(away_nick_box), "None");
			gtk_editable_set_editable(GTK_EDITABLE(away_nick_box), FALSE);
			gtk_entry_set_text(GTK_ENTRY(away_nick_pass_box), "None");
			gtk_editable_set_editable(GTK_EDITABLE(away_nick_pass_box), FALSE);
			gtk_button_clicked (GTK_BUTTON(checkbutton3));
			edit=FALSE;
	}
}

//if you choose to identify away nick
static void away_ident_yes(GtkWidget *button, void *data) {

	if (gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON(button)) &&	 edit ) {
		go_identify=TRUE;
		gtk_editable_set_editable(GTK_EDITABLE(away_nick_pass_box), TRUE);
		gtk_entry_set_text(GTK_ENTRY(away_nick_pass_box), "");
	}
	if (!edit) gtk_button_clicked (GTK_BUTTON(checkbutton3));
}

//if you do not choose to identify away nick
static void away_ident_not(GtkWidget *button, void *data) {

	if (gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON(button)) ) {
		go_identify=FALSE;
		gtk_entry_set_text(GTK_ENTRY(away_nick_pass_box), "None");
		gtk_editable_set_editable(GTK_EDITABLE(away_nick_pass_box), FALSE);
	}
}

//go away
void go_away() {

	char command[150]="away ";
	char msg[150];
	xchat_list *list;
	char command1[150]="nick ";
	char command2[150]="ns identify ";
	xchat_context *temp_focus;

	temp_focus=xchat_find_context(ph,0,0);
	strcpy(msg,message);
	strcat(command,msg);
	strcat(command1,away_nick);
	strcat(command2,away_pass);

    	if(global_away) {
		list = xchat_list_get(ph, "channels");
		if(list){
      			while(xchat_list_next(ph, list))  {
				if ( xchat_list_int(ph, list, "type") ==1 || xchat_list_int(ph, list, "type") ==2 ) {
					xchat_set_context(ph, (xchat_context *)xchat_list_str(ph, list, "context"));
					xchat_command( ph, "gui focus" );
					if ( g_hash_table_lookup(servers_names,xchat_get_info(ph, "server"))==NULL) {
						g_hash_table_insert(servers_names,
									(char*)xchat_get_info(ph, "server"),
									g_strdup((char*)xchat_get_info(ph, "nick")));
						xchat_command(ph, command);
						gtk_image_set_from_pixbuf(GTK_IMAGE(tray_icon_image), buffer9);
						if (go_change) {
							xchat_command(ph, command1);
							if (go_identify) {
								xchat_command(ph, command2);
							}
						}
					}
					else if ( xchat_list_int(ph, list, "type") ==1) xchat_printf(ph, "You are already marked away on %s server", xchat_get_info(ph, "server"));
      				}
			}
		}
	xchat_list_free(ph, list);
	}
	else { if ( g_hash_table_lookup(servers_names,xchat_get_info(ph, "server"))==NULL ) {
			g_hash_table_insert(servers_names,
						(char*)(xchat_get_info(ph, "server")),
						g_strdup(xchat_get_info(ph, "nick")));
			xchat_command(ph, command);
			if (go_change) {
				xchat_command(ph, command1);
				if (go_identify) {
					xchat_command(ph, command2);
				}
			}
		}
		else xchat_printf(ph, "You are already marked away on %s server", xchat_get_info(ph, "server"));
	}
	//suspend();
	xchat_set_context(ph,temp_focus);
	xchat_command( ph, "gui focus" );
}

//set the away msg
void set_away_msg() {

	message=gtk_entry_get_text(GTK_ENTRY(away_text));
	go_away();
}


void restore_away() {

	global_away=global_away_temp;

}

void set_global(GtkWidget *widget, gpointer   callback_data) {

	if (gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON(widget)))
	global_away=TRUE;
	else global_away=FALSE;

}

//choose the away message
void select_away() {

    GtkWidget *window = NULL;
    GtkWidget *box1;
    GtkWidget *box2,*box3,*box4;
    GtkWidget *button,*checkbutton;
    GSList *group;
    GtkWidget *global_away_button;

    global_away_temp=global_away;

    window = gtk_window_new (GTK_WINDOW_TOPLEVEL);
    gtk_window_set_title (GTK_WINDOW (window), "Select Your Favourite Away Message");
    gtk_window_set_resizable(GTK_WINDOW (window),FALSE);
    gtk_container_set_border_width (GTK_CONTAINER (window), 0);

    box1 = gtk_vbox_new (FALSE, 0);
    gtk_container_add (GTK_CONTAINER (window), box1);
    gtk_widget_show (box1);

    box2 = gtk_vbox_new (FALSE, 10);
    gtk_container_set_border_width (GTK_CONTAINER (box2), 10);
    gtk_box_pack_start (GTK_BOX (box1), box2, FALSE, FALSE, 0);
    gtk_widget_show (box2);

    box4 = gtk_hbox_new (FALSE, 10);
    gtk_container_set_border_width (GTK_CONTAINER (box4), 10);
    gtk_box_pack_start (GTK_BOX (box1), box4, FALSE, FALSE, 0);
    gtk_widget_show (box4);

    box3 = gtk_hbox_new (FALSE, 10);
    gtk_container_set_border_width (GTK_CONTAINER (box3), 10);
    gtk_box_pack_start (GTK_BOX (box1), box3, FALSE, FALSE, 0);
    gtk_widget_show (box3);

    checkbutton = gtk_radio_button_new_with_label (NULL, away_msg1);
    gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (checkbutton), FALSE);
    g_signal_connect (G_OBJECT (checkbutton), "toggled", G_CALLBACK (get_label),G_OBJECT (checkbutton));
    gtk_box_pack_start (GTK_BOX (box2), checkbutton, FALSE, FALSE, 0);
    gtk_widget_show (checkbutton);

    group = gtk_radio_button_get_group (GTK_RADIO_BUTTON (checkbutton));
    checkbutton = gtk_radio_button_new_with_label (group, away_msg2);
    gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (checkbutton), FALSE);
    g_signal_connect (G_OBJECT (checkbutton), "toggled", G_CALLBACK (get_label),G_OBJECT (checkbutton));
    gtk_box_pack_start (GTK_BOX (box2), checkbutton, FALSE, FALSE, 0);
    gtk_widget_show (checkbutton);

    group = gtk_radio_button_get_group (GTK_RADIO_BUTTON (checkbutton));
    checkbutton = gtk_radio_button_new_with_label (group, away_msg3);
    gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (checkbutton), FALSE);
    g_signal_connect (G_OBJECT (checkbutton), "toggled", G_CALLBACK (get_label),G_OBJECT (checkbutton));
    gtk_box_pack_start (GTK_BOX (box2), checkbutton, FALSE, FALSE, 0);
    gtk_widget_show (checkbutton);

    global_away_button =  gtk_check_button_new_with_label ("Apply to all servers (global away)");
    gtk_box_pack_start (GTK_BOX (box2), global_away_button, FALSE, FALSE, 0);
    gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (global_away_button), TRUE);
    g_signal_connect (G_OBJECT (global_away_button), "toggled", G_CALLBACK (set_global),&global_away_button);
    global_away=TRUE;
    gtk_widget_show (global_away_button);

    away_text = gtk_entry_new ();
    gtk_entry_set_max_length(GTK_ENTRY(away_text), 150);
    gtk_entry_set_text(GTK_ENTRY(away_text), away_msg1);
    gtk_entry_set_width_chars(GTK_ENTRY(away_text),50);
    gtk_box_pack_start (GTK_BOX (box4), away_text, FALSE, FALSE, 0);
    gtk_widget_show (away_text);

    button = gtk_button_new_with_label ("Ok");
    g_signal_connect (G_OBJECT (button), "clicked", G_CALLBACK (set_away_msg), NULL);
    g_signal_connect_swapped (G_OBJECT (button), "clicked", G_CALLBACK (gtk_widget_destroy),G_OBJECT (window));
    gtk_box_pack_start (GTK_BOX (box3), button, FALSE, FALSE, 50);
    gtk_widget_show (button);

    button = gtk_button_new_with_label ("Cancel");
    g_signal_connect (G_OBJECT (button), "clicked", G_CALLBACK (restore_away), NULL);
    g_signal_connect_swapped (G_OBJECT (button), "clicked", G_CALLBACK (gtk_widget_destroy),G_OBJECT (window));
    gtk_box_pack_start (GTK_BOX (box3), button, FALSE, FALSE, 40);

    gtk_widget_show (button);
    gtk_widget_show (window);

}

gboolean comeback(gpointer key, gpointer value, gpointer user_data) {

	char command[150];
	char temp[6]="nick ";
	char buffer[150];
	const char* oldnick;

	xchat_set_context(ph, (xchat_context *)(xchat_find_context(ph, key, NULL)));
	xchat_command( ph, "gui focus" );

	oldnick=(char*)value;
	xchat_command( ph, "away" );
	strcpy(buffer,oldnick);
	strcpy(command,temp);
	strcat(command,buffer);
	xchat_command(ph, command);
	return TRUE;

}

//come back from away
void back_away(){

	if (g_hash_table_size(servers_names)!=0) {
		xchat_context *temp_focus;
		temp_focus=xchat_find_context(ph,0,0);

		if (global_away || gtk_image_get_pixbuf(GTK_IMAGE(tray_icon_image))==buffer9 ) {
			g_hash_table_foreach_remove(servers_names,comeback,NULL);
			gtk_image_set_from_pixbuf(GTK_IMAGE(tray_icon_image), pix_xchat);
			global_away=FALSE;
		}
		else { if ( g_hash_table_lookup(servers_names,xchat_get_info(ph, "server"))!=NULL) {
				comeback((char*)xchat_get_info(ph, "server"),g_hash_table_lookup(servers_names,xchat_get_info(ph, "server")),NULL);
			g_hash_table_remove(servers_names,(char*)xchat_get_info(ph, "server"));
			}
			else xchat_printf(ph, "You are not marked away on %s server!",(char*)xchat_get_info(ph, "server"));
		}
		xchat_set_context(ph,temp_focus);
		xchat_command( ph, "gui focus" );
	}
	else xchat_printf(ph,"You are not marked away on any server!");

}

//MENU CREATION AND COMMANDS

//launch browser
void launch_browser() {

	char command[156]="exec ";
	strcat(command, bpath);
	xchat_command( ph, command );

}

//launch email
void launch_email() {

	char command[156]="exec ";
	strcat(command, epath);
	xchat_command( ph, command );

}

//launch media player
void launch_player() {

	char command[156]="exec ";
	strcat(command, ppath);
	xchat_command( ph, command );

}

//restore function
void tray_restore() {
	status=1;
	xchat_command( ph, "gui show" );
	select_event_tab(TRUE);
}

//minimize function
void tray_minimize() {
	status=0;
	xchat_command( ph, "gui hide" );
}

//exit from the tray function
void tray_exit() {

	g_hash_table_destroy(servers_names);
	if (tray_icon!=NULL) gtk_widget_destroy (GTK_WIDGET (tray_icon));
	onExit=0;
	xchat_command( ph, "timer 1 killall" );
}

void select_event_tab(gboolean stop) {

	xchat_set_context(ph, flash_ctx);
	xchat_command( ph, "gui focus" );
	if (stop) flash_stop();
}

//catch mouse clicks on icon
static gboolean tray_clicked (GtkWidget *event_box, GdkEventButton *event, gpointer data)
{
	//mouse wheel or middle click + left double click
	if ( (event->button == 1 && event->type == GDK_2BUTTON_PRESS) ||event->button == 2) {
        	if (status == 0) tray_restore();
	        else tray_minimize();
	}

	//single click gives focus only
	if (event->button == 1) select_event_tab(FALSE);

	//mouse right click
	if (event->button == 3) {
		return tray_menu (event_box, event, data);
	}

	return FALSE;
}

static void check_updates() {

	//when language implementation will be ready i'll delete this dummy var.
	char* language="en";

	if (bpath!="") {
		char command[200]="exec ";
		gchar* update_page;
		update_page=g_strdup_printf(" \'http://blight.altervista.org/scripts/plugin_updates.php?version=%s&lang=%s\'",version,language);
		strcat(command, bpath);
		strcat(command, update_page);
		xchat_command( ph, command );
	}
	else xchat_printf(ph, "You have to select a browser, use the settings tab!");

}

static void visit_website() {

	if (bpath!="") {
		char command[156]="exec ";
		strcat(command, bpath);
		strcat(command, " www.blight.tk");
		xchat_command( ph, command );
	}
	else xchat_printf(ph, "You have to select a browser, use the settings tab!");

}

static void send_email() {

	if (bpath!="") {
		char command[156]="exec ";
		strcat(command, bpath);
		strcat(command, " mailto:hetfield@email.it");
		xchat_command( ph, command );
	}
	else xchat_printf(ph, "You have to select a browser, use the settings tab!");

}

static void help_page() {

    	GtkWidget *window;
	GtkWidget *table;
	GtkWidget *button,*box1,*box2,*box3,*box4,*box5;
	GtkWidget *label;

	//create box and window
	window = gtk_window_new (GTK_WINDOW_TOPLEVEL);
	gtk_window_set_resizable(GTK_WINDOW (window),FALSE);
	gtk_window_set_title (GTK_WINDOW (window), "Help & Contact Tab");
	gtk_container_set_border_width (GTK_CONTAINER (window), 10);

	table=gtk_table_new(14,2,FALSE);
	gtk_table_set_col_spacings(GTK_TABLE(table), 0 );
	gtk_table_set_row_spacings(GTK_TABLE(table), 10 );
	gtk_container_add (GTK_CONTAINER (window), table);

	box1 = gtk_hbox_new (FALSE, 40);
	box2 = gtk_hbox_new (FALSE, 40);
	box3 = gtk_hbox_new (FALSE, 40);
	box4 = gtk_hbox_new (FALSE, 40);
	box5 = gtk_hbox_new (FALSE, 0);

	label = gtk_label_new ("\nXChat2 SysTray Integration Plugin Help & Contact Page.\n");
	gtk_table_attach_defaults(GTK_TABLE(table),label,0,2,0,1);
  	gtk_widget_show (label);

	//1 button
	gtk_table_attach_defaults(GTK_TABLE(table),box1,0,1,2,3);
	label = gtk_label_new ("Be sure you have read all the files in the Docs directory\nincluded in the plugin package before contacting the author.\nUpdates are released very often so check if you have the lastest version.\n");
	gtk_box_pack_start (GTK_BOX (box1), label, FALSE, FALSE, 0);
	gtk_widget_show (label);
	gtk_widget_show (box1);

	gtk_table_attach_defaults(GTK_TABLE(table),box2,0,1,3,4);
	label=gtk_label_new ("Your version:");
	gtk_box_pack_start (GTK_BOX (box2), label, FALSE, FALSE, 0);
	gtk_widget_show (label);

	label=gtk_label_new (version);
	gtk_box_pack_start (GTK_BOX (box2), label, FALSE, FALSE, 10);
	gtk_widget_show (label);

	button= gtk_button_new_with_label ("Check for updates");
	gtk_box_pack_start (GTK_BOX (box2), button, FALSE, FALSE, 30);
	g_signal_connect (G_OBJECT (button), "clicked", G_CALLBACK (check_updates), NULL);
	gtk_widget_show (button);
	gtk_widget_show (box2);

	gtk_table_attach_defaults(GTK_TABLE(table),box3,0,1,4,5);
	label=gtk_label_new ("\nIt's very important you to send feedback about all bugs/problems found in this Plugin.\nThis will help author to improve it. Finally more ideas and suggestions are needed.\n");
	gtk_box_pack_start (GTK_BOX (box3), label, FALSE, FALSE, 0);
	gtk_widget_show (label);
	gtk_widget_show (box3);

	label=gtk_label_new ("Write author without any fear!!");
	gtk_table_attach_defaults(GTK_TABLE(table),box4,0,1,6,7);
	gtk_box_pack_start (GTK_BOX (box4), label, FALSE, FALSE, 0);
	gtk_widget_show (label);

	button= gtk_button_new_with_label ("Send email");
	g_signal_connect (G_OBJECT (button), "clicked", G_CALLBACK (send_email), NULL);
	gtk_box_pack_start (GTK_BOX (box4), button, FALSE, FALSE, 10);
	gtk_widget_show (button);
	gtk_widget_show (box4);

	label=gtk_label_new ("Visit Plugin WebSite to keep updated about all changes and news.");
	gtk_table_attach_defaults(GTK_TABLE(table),box5,0,1,8,9);
	gtk_box_pack_start (GTK_BOX (box5), label, FALSE, FALSE, 0);
	gtk_widget_show (label);

	button= gtk_button_new_with_label ("Visit www.blight.tk");
	g_signal_connect (G_OBJECT (button), "clicked", G_CALLBACK (visit_website), NULL);
	gtk_box_pack_start (GTK_BOX (box5), button, FALSE, FALSE, 0);
	gtk_widget_show (button);
	gtk_widget_show (box5);

	//close button
	button = gtk_button_new_with_label ("Close");
	g_signal_connect_swapped (G_OBJECT (button), "clicked",G_CALLBACK (gtk_widget_destroy),G_OBJECT (window));
	gtk_table_attach_defaults(GTK_TABLE(table),button,0,1,12,13);
    	gtk_widget_show (button);

	gtk_widget_show(table);
 	gtk_widget_show (window);

}

//create menu linked to the tray icon
static gboolean tray_menu (GtkWidget *widget, GdkEventButton *event, gpointer data) {

	GtkWidget *menuImage,*item;
	static GdkPixbuf *buffer1 = NULL;
	static GdkPixbuf *buffer2;
	static GdkPixbuf *buffer3;
	static GdkPixbuf *buffer4;
	static GdkPixbuf *buffer5;
	static GdkPixbuf *buffer6;
	static GdkPixbuf *buffer7;
	static GdkPixbuf *buffer8;
	// n9 is needed outside too!
	static GdkPixbuf *buffer10;

	if (!buffer1)
	{
		/* only decode the images once */
		buffer1 = gdk_pixbuf_new_from_inline (-1, xchatsettings, FALSE, NULL);
		buffer2 = gdk_pixbuf_new_from_inline (-1, xchatbrowser, FALSE, NULL);
		buffer3 = gdk_pixbuf_new_from_inline (-1, xchatplayer, FALSE, NULL);
		buffer4 = gdk_pixbuf_new_from_inline (-1, xchatemail, FALSE, NULL);
		buffer5 = gdk_pixbuf_new_from_inline (-1, xchatmaxxpm, FALSE, NULL);
		buffer6 = gdk_pixbuf_new_from_inline (-1, xchatminxpm, FALSE, NULL);
		buffer7 = gdk_pixbuf_new_from_inline (-1, xchatquitpng, FALSE, NULL);
		buffer8 = gdk_pixbuf_new_from_inline (-1, backawaypng, FALSE, NULL);
		buffer9 = gdk_pixbuf_new_from_inline (-1, goawaypng, FALSE, NULL);
		buffer10 = gdk_pixbuf_new_from_inline (-1, helppng, FALSE, NULL);
	}

	status_menu = gtk_menu_new();

	//help item
	item = gtk_image_menu_item_new_with_label ("Help & Contact");
	menuImage = gtk_image_new_from_pixbuf (buffer10);
	gtk_container_add (GTK_CONTAINER (status_menu), item);
	gtk_image_menu_item_set_image (GTK_IMAGE_MENU_ITEM (item), menuImage);
	g_signal_connect (G_OBJECT (item), "activate",G_CALLBACK (help_page),NULL);

	//break
	item = gtk_menu_item_new ();
	gtk_widget_set_sensitive (item, FALSE);
	gtk_container_add (GTK_CONTAINER (status_menu), item);

	//setting item
	item = gtk_image_menu_item_new_with_label ("SysTray Settings");
	menuImage = gtk_image_new_from_pixbuf (buffer1);
	gtk_container_add (GTK_CONTAINER (status_menu), item);
	gtk_image_menu_item_set_image (GTK_IMAGE_MENU_ITEM (item), menuImage);
	g_signal_connect (G_OBJECT (item), "activate",G_CALLBACK (set_tray),NULL);

	//break
	item = gtk_menu_item_new ();
	gtk_widget_set_sensitive (item, FALSE);
	gtk_container_add (GTK_CONTAINER (status_menu), item);

	//Browser item
	item = gtk_image_menu_item_new_with_label ("Web Browser");
	menuImage = gtk_image_new_from_pixbuf (buffer2);
	gtk_container_add (GTK_CONTAINER (status_menu), item);
	gtk_image_menu_item_set_image (GTK_IMAGE_MENU_ITEM (item), menuImage);
	g_signal_connect (G_OBJECT (item), "activate",G_CALLBACK (launch_browser),NULL);

	//multimedia player item
	item = gtk_image_menu_item_new_with_label ("Multimedia");
	menuImage = gtk_image_new_from_pixbuf (buffer3);
	gtk_container_add (GTK_CONTAINER (status_menu), item);
	gtk_image_menu_item_set_image (GTK_IMAGE_MENU_ITEM (item), menuImage);
	g_signal_connect (G_OBJECT (item), "activate",G_CALLBACK (launch_player),NULL);

	//email item
	item = gtk_image_menu_item_new_with_label ("Email");
	menuImage = gtk_image_new_from_pixbuf (buffer4);
	gtk_container_add (GTK_CONTAINER (status_menu), item);
	gtk_image_menu_item_set_image (GTK_IMAGE_MENU_ITEM (item), menuImage);
	g_signal_connect (G_OBJECT (item), "activate",G_CALLBACK (launch_email),NULL);

	//break
	item = gtk_menu_item_new ();
	gtk_widget_set_sensitive (item, FALSE);
	gtk_container_add (GTK_CONTAINER (status_menu), item);

	//Go Away item
	item = gtk_image_menu_item_new_with_label ("Go Away");
	menuImage = gtk_image_new_from_pixbuf (buffer9);
	gtk_container_add (GTK_CONTAINER (status_menu), item);
	gtk_image_menu_item_set_image (GTK_IMAGE_MENU_ITEM (item), menuImage);
	g_signal_connect (G_OBJECT (item), "activate",G_CALLBACK (select_away),NULL);

	//Back from way
	item = gtk_image_menu_item_new_with_label ("Come Back");
	menuImage = gtk_image_new_from_pixbuf (buffer8);
	gtk_container_add (GTK_CONTAINER (status_menu), item);
	gtk_image_menu_item_set_image (GTK_IMAGE_MENU_ITEM (item), menuImage);
	g_signal_connect (G_OBJECT (item), "activate",G_CALLBACK (back_away),NULL);

	//break
	item = gtk_menu_item_new ();
	gtk_widget_set_sensitive (item, FALSE);
	gtk_container_add (GTK_CONTAINER (status_menu), item);

	//restore item
	item = gtk_image_menu_item_new_with_label ("Restore");
	menuImage = gtk_image_new_from_pixbuf (buffer5);
	gtk_container_add (GTK_CONTAINER (status_menu), item);
	gtk_image_menu_item_set_image (GTK_IMAGE_MENU_ITEM (item), menuImage);
	g_signal_connect (G_OBJECT (item), "activate",G_CALLBACK (tray_restore),NULL);

	//minimize item
	item = gtk_image_menu_item_new_with_label ("Minimize");
	menuImage = gtk_image_new_from_pixbuf (buffer6);
 	gtk_container_add (GTK_CONTAINER (status_menu), item);
	gtk_image_menu_item_set_image (GTK_IMAGE_MENU_ITEM (item), menuImage);
	g_signal_connect (G_OBJECT (item), "activate",G_CALLBACK (tray_minimize),NULL);

	//break
	item = gtk_menu_item_new ();
	gtk_widget_set_sensitive (item, FALSE);
	gtk_container_add (GTK_CONTAINER (status_menu), item);

	//stop flashing item
	item = gtk_image_menu_item_new_with_label ("Stop Flashing");
	menuImage = gtk_image_new_from_pixbuf (pix_xchat);
	gtk_container_add (GTK_CONTAINER (status_menu), item);
	gtk_image_menu_item_set_image (GTK_IMAGE_MENU_ITEM (item), menuImage);
	g_signal_connect (G_OBJECT (item), "activate",G_CALLBACK (flash_stop),NULL);

	//break
	item = gtk_menu_item_new ();
	gtk_widget_set_sensitive (item, FALSE);
	gtk_container_add (GTK_CONTAINER (status_menu), item);

	//exit item
	item = gtk_image_menu_item_new_with_label ("Exit");
	menuImage = gtk_image_new_from_pixbuf (buffer7);
	gtk_container_add (GTK_CONTAINER (status_menu), item);
	gtk_image_menu_item_set_image (GTK_IMAGE_MENU_ITEM (item), menuImage);
	g_signal_connect (G_OBJECT (item), "activate",G_CALLBACK (tray_exit),NULL);


	g_signal_connect (G_OBJECT (status_menu), "selection-done",
			  G_CALLBACK (gtk_widget_destroy), G_OBJECT (status_menu));

	//finalization
	gtk_widget_show_all (status_menu);
	gtk_menu_popup (GTK_MENU(status_menu), NULL, NULL,NULL, NULL,event->button, event->time);

	return TRUE;
}

// EVENTS HANDLING AND FLASHING

//set flashing icon
static gboolean flash_timeout(gpointer userdata) {

	static int i = 0;

	i++;
	if (i == 2) {
		i = 0;
		if (global_away) gtk_image_set_from_pixbuf(GTK_IMAGE(tray_icon_image), buffer9);
		else gtk_image_set_from_pixbuf(GTK_IMAGE(tray_icon_image), pix_xchat);
	}
	else gtk_image_set_from_pixbuf(GTK_IMAGE(tray_icon_image), icontype);
	return TRUE;

}

//make flash start
static void flash_start() {
	if (flash_id == 0) flash_id = g_timeout_add(flash_interval, flash_timeout, NULL);
}

//stop flash
static void flash_stop() {

	if(flash_id)
	{
		if (global_away) gtk_image_set_from_pixbuf(GTK_IMAGE(tray_icon_image), buffer9);
		else gtk_image_set_from_pixbuf(GTK_IMAGE(tray_icon_image), pix_xchat);
		g_source_remove(flash_id);
		flash_id = 0;
                gtk_tooltips_set_tip (tray_icon_tooltip, GTK_WIDGET (tray_icon), "XChat2 - Nothing Particular", NULL);
	}
}

//on hilight
static int noti_hilight_cb(char *word[], void *userdata) {

	if(highlight){
		if(xchat_get_context(ph) != focus_ctx || !status)
		{
			flash_ctx = xchat_get_context(ph);
			icontype=pix_xchat_blue;
			flash_start();
       	         gtk_tooltips_set_tip (tray_icon_tooltip, GTK_WIDGET (tray_icon), "XChat2 - Somebody asked for you", NULL);
		}
	}
	return XCHAT_EAT_NONE;

}

//find focus
static int noti_focus_cb(char *word[], void *userdata) {

	focus_ctx = xchat_get_context(ph);

	if(focus_ctx == flash_ctx)
		flash_stop();

	return XCHAT_EAT_NONE;
}

//on query
static int query_cb(char *word[],  void *userdata) {

	if (query){

  	     if ( xchat_get_context(ph) != focus_ctx ||!status )
		{
			flash_ctx = xchat_get_context(ph);
			icontype=pix_xchat_blue;
			flash_start();
			gtk_tooltips_set_tip (tray_icon_tooltip, GTK_WIDGET (tray_icon),"XChat2 - Somebody send you a message", NULL);
		}
	}
        return XCHAT_EAT_NONE;
}

//on disconnection
static int disconnect_cb(char *word[], void *userdata) {
	if(disconnection){

    	   if ( xchat_get_context(ph) != focus_ctx ||!status )
		{
			flash_ctx = xchat_get_context(ph);
			icontype=pix_xchat_disc;
			flash_start();
     	           gtk_tooltips_set_tip (tray_icon_tooltip, GTK_WIDGET (tray_icon), "XChat2 - Disconnected from server",
		   NULL);
		}
	}
        return XCHAT_EAT_NONE;
}

//on kick/ban
static int kicked_cb(char *word[], void *userdata) {

	if(kick){

       		if ( xchat_get_context(ph) != focus_ctx ||!status )
		{
			flash_ctx = xchat_get_context(ph);
			icontype=pix_xchat_red;
			flash_start();
         	       gtk_tooltips_set_tip (tray_icon_tooltip, GTK_WIDGET (tray_icon), "XChat2 - You have been kicked", NULL);
		}
	}
        return XCHAT_EAT_NONE;
}

//on kill
static int killed_cb(char *word[], void *userdata) {

	if (kill) {
    		   if ( xchat_get_context(ph) != focus_ctx ||!status )
		{
			flash_ctx = xchat_get_context(ph);
			icontype=pix_xchat_red;
			flash_start();
   	             gtk_tooltips_set_tip (tray_icon_tooltip, GTK_WIDGET (tray_icon), "XChat2 - You have been killed", NULL);
		}
	}
        return XCHAT_EAT_NONE;
}

//on dcc char request
static int chatreq_cb(char *word[], void *userdata) {

	if(dcc_chat) {
			flash_ctx = xchat_get_context(ph);
			icontype=pix_xchat_dcc;
			flash_start();
                	gtk_tooltips_set_tip (tray_icon_tooltip, GTK_WIDGET (tray_icon), "XChat2 - Somebody offering a dcc chat to you", NULL);

	}

        return XCHAT_EAT_NONE;
}

//on dcc send/ dcc event
static int dcc_cb(char *word[], void *userdata) {

	if(dcc_send) {
			flash_ctx = xchat_get_context(ph);
			icontype=pix_xchat_dcc;
			flash_start();
                	gtk_tooltips_set_tip (tray_icon_tooltip, GTK_WIDGET (tray_icon), "XChat2 - Somebody offering a dcc to you", NULL);
	}
        return XCHAT_EAT_NONE;
}

//on invite
static int invited_cb(char *word[], void *userdata) {

	if (invite){

		if ( xchat_get_context(ph) != focus_ctx ||!status ) {
			flash_ctx = xchat_get_context(ph);
			icontype=pix_xchat_inv;
			flash_start();
                	gtk_tooltips_set_tip (tray_icon_tooltip, GTK_WIDGET (tray_icon), "XChat2 - Somebody invited you to a channel", NULL);
		}
	}
        return XCHAT_EAT_NONE;
}

// friend away from notify
static int notout_cb(char *word[], void *userdata) {

	if (notify_list){
		if ( xchat_get_context(ph) != focus_ctx ||!status ) {
			flash_ctx = xchat_get_context(ph);
			icontype=pix_xchat_notout;
			flash_start();
                	gtk_tooltips_set_tip (tray_icon_tooltip, GTK_WIDGET (tray_icon), "XChat2 - A friend went away", NULL);
		}
	}
        return XCHAT_EAT_NONE;
}

//a new friend in notify
static int notin_cb(char *word[], void *userdata) {

	if (notify_list){
		if ( xchat_get_context(ph) != focus_ctx ||!status ) {
			flash_ctx = xchat_get_context(ph);
			icontype=pix_xchat_notin;
			flash_start();
                	gtk_tooltips_set_tip (tray_icon_tooltip, GTK_WIDGET (tray_icon), "XChat2 - A new friend online", NULL);
		}
	}
        return XCHAT_EAT_NONE;
}


//INIZIALIZATION OF PLUGIN AND TRAY ICON

// events handling
static void tray_init_xchat(void)
{
	//show warning if version is too old
	const char *str;
	int i;
 	if (xchat_get_prefs (ph, "away_size_max", &str, &i) == 0)
	version_warning();

	focus_ctx = xchat_get_context(ph);
	xchat_hook_print(ph, "Focus Tab", XCHAT_PRI_NORM, noti_focus_cb, 0);
	xchat_hook_print(ph, "Channel Action Hilight", XCHAT_PRI_NORM, noti_hilight_cb, 0);
	xchat_hook_print(ph, "Channel Msg Hilight", XCHAT_PRI_NORM, noti_hilight_cb, 0);
	xchat_hook_print(ph, "Private Message", XCHAT_PRI_NORM, query_cb, NULL);
	xchat_hook_print(ph, "Private Message to Dialog", XCHAT_PRI_NORM, query_cb, 0);
	xchat_hook_print(ph, "Disconnected", XCHAT_PRI_NORM, disconnect_cb, 0);
	xchat_hook_print(ph, "You kicked", XCHAT_PRI_NORM, kicked_cb, 0);
	xchat_hook_print(ph, "Killed", XCHAT_PRI_NORM, killed_cb, 0);
	xchat_hook_print(ph, "DCC CHAT Offer", XCHAT_PRI_NORM, chatreq_cb, 0);
	xchat_hook_print(ph, "DCC CHAT Reoffer", XCHAT_PRI_NORM, chatreq_cb, 0);
	xchat_hook_print(ph, "DCC SEND offer", XCHAT_PRI_NORM, dcc_cb, 0);
	xchat_hook_print(ph, "Invited", XCHAT_PRI_NORM, invited_cb, 0);
	xchat_hook_print(ph, "Notify Offline", XCHAT_PRI_NORM, notout_cb, 0);
	xchat_hook_print(ph, "Notify Online", XCHAT_PRI_NORM, notin_cb, 0);
	xchat_printf(ph, "SysTray Integration Plugin Version %s successfully loaded",version);
	xchat_printf(ph, "Patrizio Bassi - hetfield@email.it - http://www.blight.tk");

	//set apps variables, only on start
	get_info(TRUE,TRUE);
	servers_names = g_hash_table_new(NULL,NULL);
	window_manager_modified=KDE;
}

//used for set different options for kde like win manager
//prevents errors, destroy events etc...
void desktopSetup()
{

  GdkWindow* window=tray_icon->window;

  glong data[1];

  GdkAtom kwm_dockwindow_atom;
  GdkAtom kde_net_system_tray_window_for_atom;

  kwm_dockwindow_atom = gdk_atom_intern("KWM_DOCKWINDOW", FALSE);
  kde_net_system_tray_window_for_atom = gdk_atom_intern("_KDE_NET_WM_SYSTEM_TRAY_WINDOW_FOR", FALSE);

  /* This is the old KDE 1.0 and GNOME 1.2 way... */
  data[0] = TRUE;
  gdk_property_change(window, kwm_dockwindow_atom,
		      kwm_dockwindow_atom, 32,
		      GDK_PROP_MODE_REPLACE, (guchar *)&data, 1);

  /* This is needed to support KDE 2.0 */
  data[0] = 0;
  gdk_property_change(window, kde_net_system_tray_window_for_atom,
		      (GdkAtom)XA_WINDOW, 32,
		      GDK_PROP_MODE_REPLACE, (guchar *)&data, 1);


}

// gui start and icon setting
void tray_init_gui (void)
{
	static GtkWidget *eventbox;

	//set the pics
	pix_xchat = gdk_pixbuf_new_from_inline(-1, xchatpng, FALSE, 0);
	pix_xchat_red = gdk_pixbuf_new_from_inline(-1, xchatredpng, FALSE, 0);
	pix_xchat_blue = gdk_pixbuf_new_from_inline(-1, xchatbluepng, FALSE, 0);
	pix_xchat_dcc= gdk_pixbuf_new_from_inline(-1, xchatdccxpm, FALSE, 0);
	pix_xchat_disc= gdk_pixbuf_new_from_inline(-1, xchatdiscxpm, FALSE, 0);
	pix_xchat_inv= gdk_pixbuf_new_from_inline(-1, xchatinvxpm, FALSE, 0);
	pix_xchat_notin= gdk_pixbuf_new_from_inline(-1, xchatnotinxpm, FALSE, 0);
	pix_xchat_notout= gdk_pixbuf_new_from_inline(-1, xchatnotoutxpm, FALSE, 0);
	icontype=pix_xchat;

	//kde
 	if(KDE) {
    		tray_icon=gtk_window_new(GTK_WINDOW_TOPLEVEL);
    		gtk_window_set_title(GTK_WINDOW(tray_icon), "XChat SysTray Plugin Integration");
    		gtk_window_set_wmclass(GTK_WINDOW(tray_icon),"xchat_tray","xchat");
    		gtk_widget_set_usize(tray_icon,22,22);
  	} //not kde
  	else { tray_icon=GTK_WIDGET(egg_tray_icon_new("XChat SysTray Plugin Integration"));
      		if(tray_icon==NULL) {
		xchat_printf(ph,"Unable to create SysTray. Plugin will be unloaded.\n");
		unload_plugin();
		return;
		}
	}
  	gtk_widget_realize(tray_icon);

 	tray_icon_image = gtk_image_new_from_pixbuf (pix_xchat);
	eventbox = gtk_event_box_new ();
	gtk_widget_show (eventbox);
	gtk_container_add (GTK_CONTAINER (eventbox), tray_icon_image);
	gtk_container_add (GTK_CONTAINER (tray_icon), eventbox);
	g_signal_connect (G_OBJECT (eventbox), "button_press_event",G_CALLBACK (tray_clicked), NULL );
	g_signal_connect(GTK_OBJECT(tray_icon),"destroy", GTK_SIGNAL_FUNC(gtk_widget_destroyed),&tray_icon);
	g_signal_connect (G_OBJECT (tray_icon), "destroy",GTK_SIGNAL_FUNC(gtk_widget_destroyed), NULL);

	if (KDE) desktopSetup();

	//finalize
	gtk_widget_show_all (GTK_WIDGET (tray_icon));

	//tooltip
	tray_icon_tooltip = gtk_tooltips_new ();
	gtk_tooltips_set_tip (tray_icon_tooltip, GTK_WIDGET (tray_icon), "XChat2 - Nothing Particular", NULL);
	gtk_tooltips_set_delay(tray_icon_tooltip,1000);

}

//start gui and plugin
static void tray_init(void)
{

	//fix seg. fault on xchat-text, the XChat version without GTK
    	if (!gdk_display) {
		xchat_printf(ph,"SysTray Integration Plugin Version %s NOT loaded!\nYou are not using a GTK version of XChat2.\n",version);
              return;
	}
	tray_init_xchat();
	tray_init_gui();
}

//unloading function
int xchat_plugin_deinit(xchat_plugin *plugin_handle)
{
	if(gdk_display){
		if (onExit==1) {
		g_hash_table_destroy(servers_names);
		if (tray_icon!=NULL) gtk_widget_destroy (GTK_WIDGET (tray_icon));
		xchat_print(ph, "SysTray Integration Plugin unloaded\n");
		}
	return 1;
	}
	return 1;
}

//bootstrap
int xchat_plugin_init(
				xchat_plugin *plugin_handle,
				char **plugin_name,
				char **plugin_desc,
				char **plugin_version,
				char *arg)
{
	ph = plugin_handle;

	*plugin_name = "SysTray";
	*plugin_desc = "SysTray Integration Plugin";
	*plugin_version = "2.4.0";
	version=*plugin_version;
	tray_init();

	return 1;
}

